use std::collections::HashMap;

use serde::Deserialize;

use crate::model::icon_descriptor::IconDescriptor;

#[derive(Debug, Deserialize)]
pub struct SwitchConfig {
    pub name: String,
    #[serde(default)]
    pub icon: HashMap<SwitchState, IconDescriptor>,
}

#[derive(Debug, Deserialize)]
pub struct ButtonConfig {
    pub name: String,
    #[serde(default)]
    pub icon: HashMap<ButtonState, IconDescriptor>,
}

#[derive(Debug, Eq, PartialEq, Hash, Deserialize)]
#[serde(rename_all = "kebab-case")]
pub enum SwitchState {
    Unavailable,
    On,
    Off,
}

#[derive(Debug, Eq, PartialEq, Hash, Deserialize)]
#[serde(rename_all = "kebab-case")]
pub enum ButtonState {
    Unavailable,
    Available,
}
